#include <stdio.h>
#include <alloc.h>
#include <math.h>
#include <conio.h>

int BMP_WIDTH=200;
int BMP_HEIGHT=120;
int RANGE=BMP_WIDTH*BMP_HEIGHT+1024;
double Pi=0.017453292, xx, yy;

unsigned char (far *buf);
char *bmp;

void v_mode(int mode)
{
  asm mov ax, mode
  asm int 10h
}

void cls(void)
{
  asm
  {
    les di, buf
    mov cx, 32000
    mov al, 0
    rep stosw
  }
}

void copy_bs(void)
{
  asm
  {
    push ds
    lds si, buf
    mov ax, 0A000h
    mov es, ax
    xor di, di
    mov cx, 32000
    rep movsw
    pop ds
  }
}

void put_pixel(int x, int y, char c)
{
  asm
  {
    cmp x, 318
    ja @1
    cmp y, 199
    ja @1
//    mov ax, 0A000h
//    mov es, ax
//    xor di, di
    les di, buf
    mov ax, y
    mov bx, 320
    mul bx
    add ax, x
    add di, ax
    mov al, c
    mov ah, c
    stosw
@1:
  }
}

void set_rgb(char c, char r, char g, char b)
{
  asm
  {
    mov dx, 3C8h
    mov al, c
    out dx, al
    inc dx
    mov al, r
    out dx, al
    mov al, g
    out dx, al
    mov al, b
    out dx, al
  }
}

void load_bmp(char *filename)
{
  int i;
  FILE *f=fopen(filename, "rb");

  bmp=(char *)malloc(RANGE);
  fseek(f, 54, 0);
  fread(bmp, RANGE, 1, f);

  for (i=0;i<64;i++)
    set_rgb(i, i, 0, 0);
  for (i=0;i<64;i++)
    set_rgb(i + 64, 0, i, 0);
  for (i=0;i<64;i++)
    set_rgb(i + 128, 0, 0, i);
  for (i=0;i<64;i++)
    set_rgb(i + 192, i, i, i);
}

void rot_bmp(int angle)
{
  double x, y, offs1, offs2;

  for (int i = 0; i < BMP_HEIGHT; i++)
  {
    offs1 = cos((angle + i * 5) * Pi) * 12;
    x = offs1 / 2 + 60;
    for (int j = 0; j < BMP_WIDTH; j++)
    {
      offs2 = cos((angle + j * 5) * Pi) * 12;
      y = offs2 / 2 + 40;
      if (i < 40)
        put_pixel(j + x, i + y, 232 - offs1 - offs2);
      else if (i < 80)
        put_pixel(j + x, i + y, 168 - offs1 - offs2);
      else
        put_pixel(j + x, i + y, 40 - offs1 - offs2);
    }
  }
}

void main(void)
{
  int i, j, a=0;

  v_mode(0x13);
  load_bmp("flag.bmp");
  buf=(unsigned char far *)farmalloc(64000);
  cls();

  while (!kbhit())
  {
    cls();
    rot_bmp(a);
    copy_bs();
    a+=30;
    if (a>359) a=0;
  }

  asm
  {
    xor ax, ax
    int 16h
  }

  free(bmp);
  farfree(buf);

  v_mode(3);
}